Page MenuHomePhabricator

[CodeGen] Track DeferredDecls that have been emitted
ClosedPublic

Authored by junaire on Jul 30 2022, 10:48 PM.

Details

Summary

If we run into a first usage or definition of a mangled name, and
there's a DeferredDecl that associated with it, we should remember it we
need to emit it later on.

Without this patch, clang-repl hits a JIT symbol not found error:
clang-repl> extern "C" int printf(const char *, ...);
clang-repl> auto l1 = []() { printf("ONE\n"); return 42; };
clang-repl> auto l2 = []() { printf("TWO\n"); return 17; };
clang-repl> auto r1 = l1();
ONE
clang-repl> auto r2 = l2();
TWO
clang-repl> auto r3 = l2();
JIT session error: Symbols not found: [ l2 ]
error: Failed to materialize symbols: { (main,
{ r3, orc_init_func.incr_module_5, $.incr_module_5.inits.0 }) }

Diff Detail

Event Timeline

junaire created this revision.Jul 30 2022, 10:48 PM
Herald added a project: Restricted Project. · View Herald TranscriptJul 30 2022, 10:48 PM
junaire requested review of this revision.Jul 30 2022, 10:48 PM
Herald added a project: Restricted Project. · View Herald TranscriptJul 30 2022, 10:48 PM
Herald added a subscriber: cfe-commits. · View Herald Transcript

This looks good to me but let’s add more reviewers.

gentle ping :)

v.g.vassilev accepted this revision.Aug 25 2022, 11:11 AM

Let's move forward with this patch and rely on a post-commit review if necessary.

This revision is now accepted and ready to land.Aug 25 2022, 11:11 AM
This revision was landed with ongoing or failed builds.Aug 27 2022, 7:52 AM
This revision was automatically updated to reflect the committed changes.